<?php
// ==================================================================
// In the 3 places below that are wrapped in comments exactly like
// the ones wrapping this sentence INSERT YOUR specific information
// Author: Eric Watson @ http://www.visibilityinherit.com
// ==================================================================

// Prevent browser cache
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); 

// Remove headers
function remove_headers($string) { 
  $headers = array(
    "/to\:/i",
    "/from\:/i",
    "/bcc\:/i",
    "/cc\:/i",
    "/Content\-Transfer\-Encoding\:/i",
    "/Content\-Type\:/i",
    "/Mime\-Version\:/i" 
  ); 
  if (preg_replace($headers, '', $string) == $string) {
    return $string;
  } else {
    die('');
  }
}

// Separate headers by either \r\n or \n to ensure email sends properly
$uself = 0;
$headersep = (!isset( $uself ) || ($uself == 0)) ? "\r\n" : "\n" ;

   
// ==================================================================
// Insert your information and correct link paths here
$mailto = 'your@email.com' ;
$from = "Your Business Name Formmail" ;
$formurl = "how-to-html-form-with-php-js-captcha-validation-formmail.php" ;
$errorurl = "how-to-html-form-with-php-js-captcha-validation-error.php" ;
$thankyouurl = "how-to-html-form-with-php-js-captcha-validation-confirmation.php" ;
// ==================================================================

// ==================================================================
// Add or remove your specific Form variables here
$name = remove_headers($_POST['name']);
$email = remove_headers($_POST['email']);
$comments = remove_headers($_POST['comments']);
$spam = remove_headers($_POST['captcha']);
$http_referrer = getenv( "HTTP_REFERER" );
// ==================================================================

// ==================================================================
// Un-comment if you want to add/clean PHONE to form
// if (preg_match("{[A-Za-z]}", $phone))
// {
//   header( "Location: $errorurl" );
//	exit ;
// }
// ==================================================================

// If name or email contain carriage returns or new line characters stop execution and direct to errorurl
if ( ereg( "[\r\n]", $name ) || ereg( "[\r\n]", $email ) ) {
	header( "Location: $errorurl" );
	exit ;
}

// Clean Email - if empty ignore - if value in form input clean
if (!empty($email) && !preg_match("/^[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i",$email)) { 
    header( "Location: $errorurl" );
    exit ;
}  

// Clean Comments
if (get_magic_quotes_gpc()) {
	$comments = stripslashes( $comments );
}

// Clean Comments - max 1250 characters
if (strlen($comments) > 1250) {
$comments=substr($comments, 0, 1250).'...';
}

// Clean Comments - no URL's
if (preg_match("{link=}", $comments) || preg_match("{url=}", $comments) || preg_match("{http://}", $comments))
{
    header( "Location: $errorurl" );
	exit ;
}

// Make Name, Email, and Comments required before form submission
if (empty($name) || empty($email) ||empty($comments)) {
	header( "Location: $errorurl" );
	exit ;
}

// Clean Captcha: random numbers 1 through 5 (1+3, 4+2, 5+3, etc)
session_start();
if (!isset($_SESSION['num1']) || !isset($_SESSION['num2'])) {
	// no known session. cannot validate captcha
    header( "Location: $errorurl" );
    exit;
}
$sum = (int)$_SESSION['num1'] + (int)$_SESSION['num2'];
if (isset($_POST['captcha']) && (int)$_POST['captcha'] !== $sum) {
	// captcha given but incorrect
    header( "Location: $errorurl" );
    exit;
} else {
	// captcha correct, show a new one next time
	unset($_SESSION['num1'], $_SESSION['num2']);
}

// Send Message
$message =
	"This message was sent from:\n" .
	"$http_referrer\n\n" .
// ==================================================================	
// Add or remove your specific Form variables here
	"Name: $name\n\n" .
	"Email: $email\n\n" .
	"Comments: $comments\n\n" .
// ==================================================================
	"Captcha: $captcha\n\n" .
	"\n\n------------------------------------------------------------\n" ;

mail($mailto, $from, $message,
	"From: \"$name\" <$email>" . $headersep . "Reply-To: \"$name\" <$email>" . $headersep );
header( "Location: $thankyouurl" );
exit ;

?>